[ostree] tests: Add a test of corruption during a pull process



commit 420763e90d3d3d98249cd41c8849e6c17f9a65ac
Author: Colin Walters <walters verbum org>
Date:   Tue Jul 9 11:28:49 2013 -0400

    tests: Add a test of corruption during a pull process
    
    These corruption tests could be a lot better...like randomly try
    single bit flips, range flips.  Better, content-aware fuzzing.  But
    this is useful for now.

 Makefile-tests.am             |    1 +
 tests/libtest.sh              |    4 +++
 tests/test-pull-corruption.sh |   60 +++++++++++++++++++++++++++++++++++++++++
 3 files changed, 65 insertions(+), 0 deletions(-)
---
diff --git a/Makefile-tests.am b/Makefile-tests.am
index bc976c7..7485784 100644
--- a/Makefile-tests.am
+++ b/Makefile-tests.am
@@ -28,6 +28,7 @@ testfiles = test-basic \
        test-corruption \
        test-libarchive \
        test-pull-archive-z \
+       test-pull-corruption \
        test-admin-deploy-1 \
        test-admin-deploy-2 \
        $(NULL)
diff --git a/tests/libtest.sh b/tests/libtest.sh
index c6eb3f2..e98dd65 100644
--- a/tests/libtest.sh
+++ b/tests/libtest.sh
@@ -30,6 +30,10 @@ if test -n "$OT_TESTS_VALGRIND"; then
     CMD_PREFIX="env G_SLICE=always-malloc valgrind -q --leak-check=full --num-callers=30 
--suppressions=${SRCDIR}/ostree-valgrind.supp"
 fi
 
+assert_not_reached () {
+    echo $@ 1>&2; exit 1
+}
+
 assert_streq () {
     test "$1" = "$2" || (echo 1>&2 "$1 != $2"; exit 1)
 }
diff --git a/tests/test-pull-corruption.sh b/tests/test-pull-corruption.sh
new file mode 100755
index 0000000..7a28cce
--- /dev/null
+++ b/tests/test-pull-corruption.sh
@@ -0,0 +1,60 @@
+#!/bin/bash
+#
+# Copyright (C) 2011,2013 Colin Walters <walters verbum org>
+#
+# This library is free software; you can redistribute it and/or
+# modify it under the terms of the GNU Lesser General Public
+# License as published by the Free Software Foundation; either
+# version 2 of the License, or (at your option) any later version.
+#
+# This library is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# Lesser General Public License for more details.
+#
+# You should have received a copy of the GNU Lesser General Public
+# License along with this library; if not, write to the
+# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+# Boston, MA 02111-1307, USA.
+
+set -e
+
+. $(dirname $0)/libtest.sh
+
+setup_fake_remote_repo1 "archive-z2"
+
+echo '1..1'
+
+repopath=${test_tmpdir}/ostree-srv/gnomerepo
+cp -a ${repopath} ${repopath}.orig
+
+do_corrupt_pull_test() {
+    cd ${test_tmpdir}
+    rm repo -rf
+    mkdir repo
+    ${CMD_PREFIX} ostree --repo=repo init
+    ${CMD_PREFIX} ostree --repo=repo remote add origin $(cat httpd-address)/ostree/gnomerepo
+    if ${CMD_PREFIX} ostree --repo=repo pull origin main; then
+       assert_not_reached "pull unexpectedly succeeded!"
+    fi
+    rm -rf ${repopath}
+    cp -a ${repopath}.orig ${repopath}
+}
+
+# Corrupt .dirmeta
+someobject=$(find ${repopath} -name '*.dirmeta' | head -1)
+echo "garbage garbage garbage" > ${someobject}
+do_corrupt_pull_test
+echo "ok corrupt dirmeta"
+
+# Corrupt .dirtree
+someobject=$(find ${repopath} -name '*.dirtree' | head -1)
+echo "garbage garbage garbage" > ${someobject}
+do_corrupt_pull_test
+echo "ok corrupt dirtree"
+
+# Corrupt .filez
+someobject=$(find ${repopath} -name '*.filez' | head -1)
+echo "garbage garbage garbage" > ${someobject}
+do_corrupt_pull_test
+echo "ok corrupt filez"


[Date Prev][Date Next]   [Thread Prev][Thread Next]   [Thread Index] [Date Index] [Author Index]